{|-----------------------------------------------------------------------------|
 |                                 HEREA SOFT                                  |
 |                                 WindowsSpy                                  |
 |                                                                             |
 |                  Ecrit par Alexandre le Grand (c) Juin 2000                 |
 |                      alexandre.le.grand@libertysurf.fr                      |
 |                               Version 1.0.0                                 |
 |-----------------------------------------------------------------------------|}

unit MainUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, ActnList,TLHelp32, Buttons, CheckLst;

type
  TMainForm = class(TForm)
    Label1: TLabel;
    ListBox1: TListBox;
    CdmSpy: TSpeedButton;
    CdmStop: TSpeedButton;
    CdmQuit: TSpeedButton;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    procedure CdmSpyClick(Sender: TObject);
    procedure CdmStopClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure CdmQuitClick(Sender: TObject);

  private
  public
    { Dclarations publiques }
  end;

var
  MainForm: TMainForm;
  LOok : Bool;

implementation

{$R *.DFM}

//------------------------------------------------------------------------------

function GetModule(Hdl : HWND;ProcessID : Cardinal) : ShortString;
var
ProcessEntry  : TProcessEntry32;
Snap  : Integer;
begin
Snap := CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS, 0);
   try
   ProcessEntry.dwSize := SizeOf(ProcessEntry);
   if(Process32First(Snap,ProcessEntry))then
   begin
     repeat
       if ProcessEntry.th32ProcessID = ProcessID then
       begin
         Result := StrPas(ProcessEntry.szExeFile);
         Break;
       end;
     until not(Process32Next(Snap,ProcessEntry));
   end;
   finally
   Windows.CloseHandle(Snap);
   end;
end;

procedure TMainForm.CdmSpyClick(Sender: TObject);
Var
Pt : TPoint;
Hdl : Hwnd;
WText,ClassName : Array[0..255] of Char;
ProcessId : Cardinal;
X, y : Integer;
begin
Look:=True;
CdmQuit.Enabled:=false;
CdmSpy.Enabled:=False;
CdmStop.Enabled:=True;
X:=0;Y:=0;
Repeat

  If (GetCursorPos(Pt)) then
    If (Pt.x<>X) and (Pt.y<>Y) then
    Begin
      Caption:='WindowsSpy - x = ' + IntToStr(Pt.x) + ' : y = ' + IntToStr(Pt.y);
      ListBox1.Clear;
      X:=Pt.x;Y:=Pt.y;
      Hdl:=WindowFRomPoint(Pt);
      ListBox1.Items.Add('Handle de la fentre : ' + IntToStr(Hdl));
      GetWindowText(hdl,WText,SizeOf(WText));
      ListBox1.Items.Add('Texte de la fentre : ' + String(WText));
      GetClassName(hdl,ClassName,SizeOf(ClassName));
      ListBox1.Items.Add('Nom de classe : ' +  String(ClassName));
      GetWindowThreadProcessId(Hdl,@ProcessId);
      ListBox1.Items.Add('ID du processus : ' + IntToStr(ProcessID));
      ListBox1.Items.Add('Nom du module : ' + GetModule(Hdl,ProcessID));
      Application.ProcessMessages;
    end;
Until Look=false;
End;
procedure TMainForm.CdmStopClick(Sender: TObject);
begin
  ListBox1.Clear;
  ListBox1.Items.Add('                      Pour rcuprer des informations sur une fentre :');
  ListBox1.Items.Add('       Cliquez sur <Espionner>, puis dplacez la souris sur cette fentre.');
  CdmQuit.Enabled:=True;
  CdmSpy.Enabled:=True;
  CdmStop.Enabled:=False;
  Caption:='WindowsSpy';
  Look:=False;
end;

procedure TMainForm.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  If look then canclose:=false else canclose:=true;
end;

procedure TMainForm.CdmQuitClick(Sender: TObject);
begin
  close;
end;

end.
